@echo off
if _%1==_ goto default
:again
goto %1
goto exit

:default
	call make drivers
	if errorlevel 1 goto exit
	cd events
	make.exe -fmakefile.gcc
	if errorlevel 1 goto exit
	cd ..
	cd src
	make.exe -fmakefile.gcc
	if errorlevel 1 goto exit
	cd ..
	goto end

:test
	call make default
	if errorlevel 1 goto exit
	cd test
	make.exe -fmakefile.gcc
	if errorlevel 1 goto exit
	cd ..
	goto end

:turboc
	call make drivers
	if errorlevel 1 goto exit
	cd events
	make.exe -fmakefile.tcc
	if errorlevel 1 goto exit
	cd ..
	cd src
	make.exe -fmakefile.tcc
	if errorlevel 1 goto exit
	cd ..
	goto end

:turbotst
	call make turboc
	if errorlevel 1 goto exit
	cd test
	make.exe -fmakefile.tcc
	if errorlevel 1 goto exit
	cd ..
	goto end

:drivers
	cd drivers
	make
	if errorlevel 1 goto exit
	cd ..
	cd ndrivers
	make
	if errorlevel 1 goto exit
	cd ..
	goto end

:all
	call make turbotst
	if errorlevel 1 goto exit
	call make test
	if errorlevel 1 goto exit
	goto end

:clean
	del events\*.o*
	del events\*.exe
	del events\*.map
	del src\stamp*.*
	del src\*.o
	del src\*.oo
	del src\*.obj
	del fntool\*.exe
	del fntool\*.o
	del fntool\*.obj
	del fntool\fntool
	del test\*.exe
	del test\*
	del test\*.o
	del test\*.obj
	del utils\*.exe
	cd drivers
	make clean
	cd ..\ndrivers
	make clean
	cd ..
	goto end

:cleanall
	call make clean
	cd drivers
	make cleanall
	cd ..\ndrivers
	make cleanall
	cd ..
	del lib\*.a
	del lib\*.lib
	goto end


:end
shift
if not _%1==_ goto again
:exit

