/** 
 ** FAKECLIP.H 
 **
 **  Copyright (C) 1992, Csaba Biegl
 **    820 Stirrup Dr, Nashville, TN, 37221
 **    csaba@vuse.vanderbilt.edu
 **
 **  This file is distributed under the terms listed in the document
 **  "copying.cb", available from the author at the address above.
 **  A copy of "copying.cb" should accompany this file; if not, a copy
 **  should be available from where this file was obtained.  This file
 **  may not be distributed without a verbatim copy of "copying.cb".
 **  You should also have received a copy of the GNU General Public
 **  License along with this program (it is in the file "copying");
 **  if not, write to the Free Software Foundation, Inc., 675 Mass Ave,
 **  Cambridge, MA 02139, USA.
 **
 **  This program is distributed in the hope that it will be useful,
 **  but WITHOUT ANY WARRANTY; without even the implied warranty of
 **  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 **  GNU General Public License for more details.
 **/

#ifndef _CLIPPING_H_
#define _CLIPPING_H_

#define INSIDE		0
#define CLIPPED		1
#define OUTSIDE		2

#ifndef WHEN_CLIPPED
#define WHEN_CLIPPED
#endif

#ifndef WHEN_OUTSIDE
#define WHEN_OUTSIDE
#endif

#define CLIPDOT(c,xx,yy)

#define CLIPDOTTOCONTEXT(c,xx,yy)

#define CLIPHLINE(c,x1,x2,yy) {						\
    if(x1 > x2) EXCHG(x1,x2);						\
}

#define CLIPVLINE(c,xx,y1,y2) {						\
    if(y1 > y2) EXCHG(y1,y2);						\
}

#define CLIPBOX(c,x1,y1,x2,y2) {					\
    if(x1 > x2) EXCHG(x1,x2);						\
    if(y1 > y2) EXCHG(y1,y2);						\
}

#define CLIPSORTEDBOX(c,x1,y1,x2,y2)

#define CLIPBOXTOCONTEXT(c,x1,y1,x2,y2) {				\
    if(x1 > x2) EXCHG(x1,x2);						\
    if(y1 > y2) EXCHG(y1,y2);						\
}

#define CLIPLINE(c,x1,y1,x2,y2) {					\
    if(x1 > x2) { EXCHG(x1,x2); EXCHG(y1,y2); }				\
}

#undef  MOUSE_FLAG
#undef  MOUSE_BLOCK
#undef  MOUSE_UNBLOCK

#define MOUSE_FLAG
#define MOUSE_BLOCK(cxt,x1,y1,x2,y2)
#define MOUSE_UNBLOCK()


#define GrPlot	      GrPlotNC
#define GrLine	      GrLineNC
#define GrHLine	      GrHLineNC
#define GrVLine	      GrVLineNC
#define GrBox	      GrBoxNC
#define GrFilledBox   GrFilledBoxNC
#define GrFramedBox   GrFramedBoxNC
#define GrPixel	      GrPixelNC

#endif /* whole file */

