/** 
 ** P4PIXSET.C 
 **
 **  Copyright (C) 1992, Csaba Biegl
 **    820 Stirrup Dr, Nashville, TN, 37221
 **    csaba@vuse.vanderbilt.edu
 **
 **  This file is distributed under the terms listed in the document
 **  "copying.cb", available from the author at the address above.
 **  A copy of "copying.cb" should accompany this file; if not, a copy
 **  should be available from where this file was obtained.  This file
 **  may not be distributed without a verbatim copy of "copying.cb".
 **  You should also have received a copy of the GNU General Public
 **  License along with this program (it is in the file "copying");
 **  if not, write to the Free Software Foundation, Inc., 675 Mass Ave,
 **  Cambridge, MA 02139, USA.
 **
 **  This program is distributed in the hope that it will be useful,
 **  but WITHOUT ANY WARRANTY; without even the implied warranty of
 **  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 **  GNU General Public License for more details.
 **/

#include "p4.h"

void _GrP4SetPixel(long addr,int color)
{
	pixptr p = P_ADDRESS(CURC,addr);
	int mask = 0x80 >> P_OFFSET(addr);
	int opr  = C_OPER(color);
	int plane;

	if(CURC->gc_onscreen) {
	    _SetVideoColor((color & 0x0f),opr);
	    _SetVGAWriteMask(mask);
	    (*p)++;
	    return;
	}
	opr <<= 1;
	for(plane = 4; --plane >= 0; color >>= 1) {
	    switch(opr | (color & 1)) {
	      case C_XOR2+1:
		*p ^= mask;
		break;
	      case C_OR2+1:
	      case C_SET2+1:
		*p |= mask;
		break;
	      case C_AND2+0:
	      case C_SET2+0:
		*p &= ~mask;
		break;
	    }
	    p = (pixptr)((long)p + CURC->gc_planeoffset);
	}
}

