/**
 ** P8PIXCOL.C
 **
 **  Copyright (C) 1992, Csaba Biegl
 **    820 Stirrup Dr, Nashville, TN, 37221
 **    csaba@vuse.vanderbilt.edu
 **
 **  This file is distributed under the terms listed in the document
 **  "copying.cb", available from the author at the address above.
 **  A copy of "copying.cb" should accompany this file; if not, a copy
 **  should be available from where this file was obtained.  This file
 **  may not be distributed without a verbatim copy of "copying.cb".
 **  You should also have received a copy of the GNU General Public
 **  License along with this program (it is in the file "copying");
 **  if not, write to the Free Software Foundation, Inc., 675 Mass Ave,
 **  Cambridge, MA 02139, USA.
 **
 **  This program is distributed in the hope that it will be useful,
 **  but WITHOUT ANY WARRANTY; without even the implied warranty of
 **  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 **  GNU General Public License for more details.
 **/

#include "p8.h"
#include "memfill.h"

void _GrP8SetPixColumn(long addr,int color,int height)
{
	pixptr p = P_ADDRESS(CURC,addr);
	int skip = CURC->gc_lineoffset;
	int oper = C_OPER(color);

	if(height <= 0) return;
	if((_GrP8DrawTable[oper] ^ (color &= C_SIGNIF)) == 0) return;
	if(_GrP8UsePlanarMode) PLANAR_MODE_OFF();
	_ClrDir();
	switch(oper) {
	    case C_XOR: _ColSetXorB(X,p,skip,color,height); break;
	    case C_OR:  _ColSetOrB(O,p,skip,color,height);  break;
	    case C_AND: _ColSetAndB(A,p,skip,color,height); break;
	    default:	_ColSetB(W,p,skip,color,height);    break;
	}
}

