/**
 ** SWCHAR.C
 **
 **  Copyright (C) 1992, Csaba Biegl
 **    820 Stirrup Dr, Nashville, TN, 37221
 **    csaba@vuse.vanderbilt.edu
 **
 **  This file is distributed under the terms listed in the document
 **  "copying.cb", available from the author at the address above.
 **  A copy of "copying.cb" should accompany this file; if not, a copy
 **  should be available from where this file was obtained.  This file
 **  may not be distributed without a verbatim copy of "copying.cb".
 **  You should also have received a copy of the GNU General Public
 **  License along with this program (it is in the file "copying");
 **  if not, write to the Free Software Foundation, Inc., 675 Mass Ave,
 **  Cambridge, MA 02139, USA.
 **
 **  This program is distributed in the hope that it will be useful,
 **  but WITHOUT ANY WARRANTY; without even the implied warranty of
 **  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 **  GNU General Public License for more details.
 **/

#include "grx.h"
#include "libgrx.h"

#define PROTO	long,int,int,char far *,int,int
extern  void	_GrVoidDriver(PROTO);

static void (*drawchartab[])(PROTO) = {
    _GrVoidDriver,
    USE_DRIVER_1(_GrP1DrawChar),
    USE_DRIVER_4(_GrP4DrawChar),
    USE_DRIVER_8(_GrP8DrawChar),
    USE_DRIVER_H(_GrPHDrawChar),
    USE_DRIVER_X(_GrPXDrawChar),
    USE_DRIVER_I(_GrPIDrawChar),
    USE_DRIVER_S(_GrPSDrawChar)
};

static void drawchar(long addr,int w,int h,char far *bits,int fg,int bg)
{
	_GrDrawChar = drawchartab[_GrDriverIndex];
	_GrResetValues[DrawCharIndex] = (handler)drawchar;
	_GrResetAddresses[DrawCharIndex] = (handler *)(&_GrDrawChar);
	(*_GrDrawChar)(addr,w,h,bits,fg,bg);
}

void (*_GrDrawChar)(PROTO) = drawchar;

